SystemOrganization addCategory: #'Pier-JQuery-Seaside-Widgets'!

PRStructuresWidget subclass: #PRJQuerySearchWidget
	instanceVariableNames: 'searchText'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-JQuery-Seaside-Widgets'!

!PRJQuerySearchWidget class methodsFor: 'accessing-defaults' stamp: 'NickAger 2/1/2010 17:11'!
defaultMaxItems
	^ 10! !

!PRJQuerySearchWidget class methodsFor: 'accessing-description' stamp: 'NickAger 2/2/2010 22:38'!
descriptionDropdownList
	^ nil! !

!PRJQuerySearchWidget class methodsFor: 'accessing-description' stamp: 'NickAger 2/1/2010 17:11'!
descriptionExampleText
	^ MAStringDescription new
		accessor: #exampleText;
		default: 'Search';
		label: 'Example';
		priority: 400;
		yourself! !

!PRJQuerySearchWidget class methodsFor: 'accessing-description' stamp: 'NickAger 2/26/2010 14:57'!
descriptionStructure
	^ PRStructureDescription new
		accessor: #startAt;
		label: 'Start At';
		priority: 200;
		yourself! !

!PRJQuerySearchWidget class methodsFor: 'accessing' stamp: 'NickAger 1/30/2010 13:19'!
groupLabel
	^ 'Pier Search'! !

!PRJQuerySearchWidget class methodsFor: 'testing' stamp: 'NickAger 1/30/2010 13:19'!
isAbstract
	^ false! !

!PRJQuerySearchWidget class methodsFor: 'accessing' stamp: 'NickAger 1/30/2010 13:20'!
label
	^ 'Search Field (JQuery autocomplete)'! !

!PRJQuerySearchWidget methodsFor: 'accessing-settings' stamp: 'NickAger 1/30/2010 13:07'!
dropdownList
	^ false
! !

!PRJQuerySearchWidget methodsFor: 'private' stamp: 'NickAger 2/2/2010 09:58'!
exampleText
	^ self read: #descriptionExampleText! !

!PRJQuerySearchWidget methodsFor: 'private' stamp: 'NickAger 2/26/2010 12:26'!
getCanvas 
	| document renderer context |
	document := WAHtmlDocument on: (WriteStream on: String new).
	context := WARenderContext new.
	context document: document.
	context actionUrl: self requestContext request url.
	renderer := WAHtmlCanvas context: context.
	^ renderer! !

!PRJQuerySearchWidget methodsFor: 'rendering' stamp: 'NickAger 3/7/2010 21:09'!
renderContentOn: html
	html textInput
		script: (html jQuery this autocomplete
			sourceCallback: [ :term | self searchResultsFor: term];
			onSelect: 'document.location.href=arguments[1].item.url');
		script: (html jQuery this example: self exampleText class: 'PRJQuerySearchWidgetExampleText')
! !

!PRJQuerySearchWidget methodsFor: 'private' stamp: 'NickAger 2/26/2010 14:52'!
searchResultsFor: searchTerm
	| results maxItems |
	
	searchText := searchTerm.
	results := self items.
	maxItems := self maxItems.
	results size > maxItems 
		ifTrue: [results := results first: maxItems].
		
	"Pass a (json) array of  objects back to the client. The #label property is used by the
	 JQuery autocomplete code, #url is specific to this code
	 See: http://docs.jquery.com/UI/Autocomplete"
	^ results collect: [:each | | url |
		Dictionary newFromPairs: (
			Array with: #label with: (self labelFor: each)
			with: #url with: (self urlOn: (self context structure: each)))]
	
! !

!PRJQuerySearchWidget methodsFor: 'private' stamp: 'NickAger 2/1/2010 10:01'!
searchText
	^ searchText
		! !

!PRJQuerySearchWidget methodsFor: 'accessing' stamp: 'NickAger 3/3/2010 12:03'!
structure
	"Answer the structure from where the widget should begin it's recursive search"
	^ (self read: #descriptionStructure) ifNil: [ self context root ]! !

!PRJQuerySearchWidget methodsFor: 'accessing' stamp: 'NickAger 2/26/2010 14:55'!
unfilteredItems
	^ (self structure fullTextSearch subString: self searchText) contents! !

!PRJQuerySearchWidget methodsFor: 'rendering' stamp: 'NickAger 3/7/2010 21:22'!
updateRoot: anHtmlRoot
		super updateRoot: anHtmlRoot.	 
			
		"assume that jQuery libraries are already loaded"
		anHtmlRoot javascript url: JQWidgetBoxDeploymentLibrary / #jqueryexampleminJs.
		anHtmlRoot stylesheet add: '.PRJQuerySearchWidgetExampleText {color: gray;}'! !

!PRJQuerySearchWidget methodsFor: 'private' stamp: 'NickAger 2/26/2010 14:47'!
urlOn: aContext
	| url sessionField |
	url := aContext urlOn: self getCanvas.
	sessionField := url queryFields at: '_s' ifAbsent: [nil].
	url purgeSeasideFields.
	sessionField ifNotNil: [url queryFields at: '_s' put: sessionField].
	
	^ url greaseString.	
! !
